
#ifndef __H_GAME_UTILS__
#define __H_GAME_UTILS__

/**
 * This file, as the rest of the project is under MIT license.
 * see http://opensource.org/licenses/MIT
 *
 * Author Gustav Hartvigsson <gustav.hartvigsson _at_ gmail.com> 2014
 */

#include <SDL2/SDL.h>

/**
 * This file contains a set of utility functions.
 */

/**
 * Sets the renderer draw colour to the color inputted, and returns the old
 * renderer colour.
 */
SDL_Color game_color_set_draw_color (SDL_Renderer * renderer,
                                                   const SDL_Color color);

SDL_Color game_color_create_color (int r, int g, int b, int a);

SDL_Rect game_rect_create_rect (int x, int y, int h, int w);

SDL_Rect * game_rect_new (int x, int y, int h, int w);

void print_error (const char * str, ... );

#endif
